package com.casic.dcms.ui;

import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.text.TextUtils;
import android.view.View;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.Nullable;
import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.casic.dcms.R;
import com.casic.dcms.adapter.ImageRecycleViewAdapter;
import com.casic.dcms.base.BaseCaseActivity;
import com.casic.dcms.bean.ActionResultBean;
import com.casic.dcms.bean.CaseLargeClassBean;
import com.casic.dcms.bean.CaseSmallClassBean;
import com.casic.dcms.mvp.presenter.CaseLargeClassPresenterImpl;
import com.casic.dcms.mvp.presenter.CaseSmallClassPresenterImpl;
import com.casic.dcms.mvp.presenter.CaseSubmitPresenterImpl;
import com.casic.dcms.mvp.presenter.UploadImagePresenterImpl;
import com.casic.dcms.mvp.view.ICaseLargeClassView;
import com.casic.dcms.mvp.view.ICaseSmallClassView;
import com.casic.dcms.mvp.view.ICaseSubmitCaseView;
import com.casic.dcms.mvp.view.IUploadFileView;
import com.casic.dcms.utils.ColorHelper;
import com.casic.dcms.utils.Constant;
import com.casic.dcms.utils.FileUtils;
import com.casic.dcms.utils.GlideLoadEngine;
import com.casic.dcms.utils.ItemDecorationSpace;
import com.casic.dcms.utils.OtherUtils;
import com.casic.dcms.utils.StringHelper;
import com.casic.dcms.utils.ToastHelper;
import com.luck.picture.lib.PictureSelector;
import com.luck.picture.lib.config.PictureConfig;
import com.luck.picture.lib.config.PictureMimeType;
import com.luck.picture.lib.entity.LocalMedia;
import com.luck.picture.lib.tools.PictureFileUtils;
import com.qmuiteam.qmui.widget.dialog.QMUIBottomSheet;
import com.qmuiteam.qmui.widget.dialog.QMUIDialog;
import com.qmuiteam.qmui.widget.dialog.QMUITipDialog;
import com.qmuiteam.qmui.widget.roundwidget.QMUIRoundButton;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.OnClick;

public class CaseUploadQuicklyActivity extends BaseCaseActivity implements View.OnClickListener,
        ICaseLargeClassView, ICaseSmallClassView, ICaseSubmitCaseView, IUploadFileView {

    private Context context = this;

    @BindView(R.id.caseClassView)
    TextView caseClassView;
    @BindView(R.id.caseLargeClassView)
    TextView caseLargeClassView;
    @BindView(R.id.caseSmallClassView)
    TextView caseSmallClassView;
    @BindView(R.id.communityNameView)
    EditText communityNameView;
    @BindView(R.id.longitudeView)
    TextView longitudeView;
    @BindView(R.id.latitudeView)
    TextView latitudeView;
    @BindView(R.id.locationMapView)
    ImageView locationMapView;
    @BindView(R.id.caseLocationView)
    EditText caseLocationView;
    @BindView(R.id.caseDetailEditView)
    EditText caseDetailEditView;
    @BindView(R.id.selectedResultView)
    RecyclerView selectedResultView;
    @BindView(R.id.addImageView)
    ImageView addImageView;
    @BindView(R.id.submitButton)
    QMUIRoundButton submitButton;

    private CaseLargeClassPresenterImpl caseLargeClassPresenter;
    private CaseSmallClassPresenterImpl caseSmallClassPresenter;
    private CaseSubmitPresenterImpl caseSubmitPresenter;
    private List<CaseLargeClassBean.DataBean> largeClassBeans;
    private List<CaseSmallClassBean.DataBean> smallClassBeans;
    private QMUITipDialog submitDialog;
    private UploadImagePresenterImpl uploadImagePresenter;
    private ArrayList<String> realPaths = new ArrayList<>();//真是图片路径
    private List<String> imageList = new ArrayList<>();//上传到服务器的数据集
    private String eorc = "请选择";
    private String typeCode = "请选择";
    private String typeDetailCode = "请选择";//默认值，防止用户不选择直接跳过
    private ImageRecycleViewAdapter imageAdapter;
    private String gridId;

    @Override
    public int initLayoutView() {
        return R.layout.activity_case_upload_quickly;
    }

    @Override
    protected String setTitleName() {
        return "快速上报";
    }

    @Override
    public void initData() {
        largeClassBeans = new ArrayList<>();
        smallClassBeans = new ArrayList<>();
        caseLargeClassPresenter = new CaseLargeClassPresenterImpl(this);
        caseSmallClassPresenter = new CaseSmallClassPresenterImpl(this);
        caseSubmitPresenter = new CaseSubmitPresenterImpl(this);
        submitDialog = new QMUITipDialog.Builder(this)
                .setIconType(QMUITipDialog.Builder.ICON_TYPE_LOADING)
                .setTipWord("提交中，请稍后")
                .create();
        uploadImagePresenter = new UploadImagePresenterImpl(this);
        imageAdapter = new ImageRecycleViewAdapter(this);
        selectedResultView.setLayoutManager(new GridLayoutManager(this, 2));
        selectedResultView.addItemDecoration(new ItemDecorationSpace());
        selectedResultView.setAdapter(imageAdapter);
    }

    @Override
    public void initEvent() {
        submitButton.setChangeAlphaWhenPress(true);
    }

    @OnClick({R.id.caseClassLayout, R.id.caseLargeClassLayout, R.id.caseSmallClassLayout, R.id.locationMapView, R.id.addImageView, R.id.submitButton})
    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.caseClassLayout:
                new QMUIBottomSheet.BottomListSheetBuilder(this)
                        .setTitle("案卷类型")
                        .addItem("事件")
                        .addItem("部件")
                        .setGravityCenter(true)
                        .setOnSheetItemClickListener(new QMUIBottomSheet.BottomListSheetBuilder.OnSheetItemClickListener() {
                            @Override
                            public void onClick(QMUIBottomSheet dialog, View itemView, int position, String tag) {
                                dialog.dismiss();
                                caseClassView.setText(tag);
                                caseClassView.setTextColor(ColorHelper.getResourcesColor(context, R.color.textColor));

                                //获取案卷大类
                                caseLargeClassPresenter.onReadyRetrofitRequest(String.valueOf(position + 1));
                            }
                        }).build().show();
                break;
            case R.id.caseLargeClassLayout:
                if (largeClassBeans != null) {
                    if (largeClassBeans.size() > 1) {
                        QMUIBottomSheet.BottomListSheetBuilder sheetBuilder = new QMUIBottomSheet.BottomListSheetBuilder(this);
                        sheetBuilder.setTitle("案卷大类");
                        for (CaseLargeClassBean.DataBean dataBean : largeClassBeans) {
                            sheetBuilder.addItem(dataBean.getTypeName());
                        }
                        sheetBuilder.setGravityCenter(true).setOnSheetItemClickListener(new QMUIBottomSheet.BottomListSheetBuilder.OnSheetItemClickListener() {
                            @Override
                            public void onClick(QMUIBottomSheet dialog, View itemView, int position, String tag) {
                                dialog.dismiss();
                                caseLargeClassView.setText(tag);
                                caseLargeClassView.setTextColor(ColorHelper.getResourcesColor(context, R.color.textColor));

                                //获取案卷小类
                                CaseLargeClassBean.DataBean dataBean = largeClassBeans.get(position);
                                eorc = dataBean.getEorc();
                                typeCode = dataBean.getTypeCode();
                                String typeId = dataBean.getId();

                                caseSmallClassPresenter.onReadyRetrofitRequest(eorc, typeId);
                            }
                        }).build().show();
                    }
                }
                break;
            case R.id.caseSmallClassLayout:
                if (smallClassBeans != null) {
                    if (smallClassBeans.size() > 1) {
                        QMUIBottomSheet.BottomListSheetBuilder sheetBuilder = new QMUIBottomSheet.BottomListSheetBuilder(this);
                        sheetBuilder.setTitle("案卷小类");
                        for (CaseSmallClassBean.DataBean dataBean : smallClassBeans) {
                            sheetBuilder.addItem(dataBean.getTypeDetailName());
                        }
                        sheetBuilder.setGravityCenter(true).setOnSheetItemClickListener(new QMUIBottomSheet.BottomListSheetBuilder.OnSheetItemClickListener() {
                            @Override
                            public void onClick(QMUIBottomSheet dialog, View itemView, int position, String tag) {
                                dialog.dismiss();
                                caseSmallClassView.setText(tag);
                                caseSmallClassView.setTextColor(ColorHelper.getResourcesColor(context, R.color.textColor));

                                typeDetailCode = smallClassBeans.get(position).getTypeDetailCode();
                            }
                        }).build().show();
                    }
                }
                break;
            case R.id.addImageView:
                new QMUIDialog.MenuDialogBuilder(this)
                        .addItem("相册中选取", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                dialog.dismiss();
                                //选图
                                selectPicture();
                            }
                        })
                        .addItem("相机拍照", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                dialog.dismiss();
                                //拍照
                                takePicture();
                            }
                        })
                        .create().show();
                break;
            case R.id.locationMapView:
                //根据情况加载不同图层
                String type = caseClassView.getText().toString();
                if (type.equals("请选择")) {
                    ToastHelper.showToast("请先选择案卷类型", ToastHelper.WARING);
                    return;
                }
                Intent intent = new Intent(this, ArcGISMapActivity.class);
                intent.putExtra("type", type);
                startActivityForResult(intent, Constant.REQUEST_MAP_CODE);
                break;
            case R.id.submitButton:
                submitCase();//案卷提交
                break;
            default:
                break;
        }
    }

    private void selectPicture() {
        PictureSelector.create(this)
                .openGallery(PictureMimeType.ofImage())
                .imageEngine(GlideLoadEngine.createGlideEngine())
                .maxSelectNum(2)
                .isCompress(true)
                .compressQuality(80)
                .compressSavePath(FileUtils.getImageCompressPath())
                .forResult(PictureConfig.CHOOSE_REQUEST);
    }

    private void takePicture() {
        PictureSelector.create(this)
                .openCamera(PictureMimeType.ofImage())
                .imageEngine(GlideLoadEngine.createGlideEngine())
                .maxSelectNum(1)
                .isCompress(true)
                .compressQuality(80)
                .compressSavePath(FileUtils.getImageCompressPath())
                .forResult(PictureConfig.REQUEST_CAMERA);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (resultCode == RESULT_OK) {
            switch (requestCode) {
                case PictureConfig.CHOOSE_REQUEST:
                    List<LocalMedia> selectList = PictureSelector.obtainMultipleResult(data);
                    for (LocalMedia media : selectList) {
                        String mediaCompressPath = media.getCompressPath();
                        uploadImagePresenter.onReadyRetrofitRequest(new File(mediaCompressPath));
                    }
                    break;
                case PictureConfig.REQUEST_CAMERA:
                    LocalMedia localMedia = PictureSelector.obtainMultipleResult(data).get(0);
                    uploadImagePresenter.onReadyRetrofitRequest(new File(localMedia.getCompressPath()));
                    break;
                case Constant.REQUEST_MAP_CODE:
                    if (data == null) {
                        return;
                    }
                    double longitude = data.getDoubleExtra("longitude", 0);
                    double latitude = data.getDoubleExtra("latitude", 0);
                    gridId = data.getStringExtra("gridId");
                    String community = data.getStringExtra("community");

                    longitudeView.setText(String.valueOf(longitude));
                    latitudeView.setText(String.valueOf(latitude));
                    communityNameView.setText(community);
                    break;
                default:
                    break;
            }
        }
    }

    @Override
    public void obtainLargeClassData(CaseLargeClassBean largeClassBean) {
//        Log.d(TAG, "obtainLargeClassData: " + gson.toJson(largeClassBean));
        if (largeClassBean.isSuccess()) {
            //设置大类数据
            this.largeClassBeans = largeClassBean.getData();
            if (largeClassBeans.size() == 0) {
                caseLargeClassView.setText("无小类");
            } else {
                caseLargeClassView.setText(largeClassBeans.get(0).getTypeName());//默认选择第一个
            }
            caseLargeClassView.setTextColor(ColorHelper.getResourcesColor(this, R.color.darkGray));

            caseSmallClassView.setText("请选择");
            caseSmallClassView.setTextColor(ColorHelper.getResourcesColor(this, R.color.darkGray));
        }
    }

    @Override
    public void obtainSmallClassData(CaseSmallClassBean smallClassBean) {
//        Log.d(TAG, "obtainSmallClassData: " + new Gson().toJson(smallClassBean));
        if (smallClassBean.isSuccess()) {
            //设置大类数据
            this.smallClassBeans = smallClassBean.getData();
            if (smallClassBeans.size() == 0) {
                caseSmallClassView.setText("无小类");
            } else {
                caseSmallClassView.setText(smallClassBeans.get(0).getTypeDetailName());//默认选择第一个
            }
            caseSmallClassView.setTextColor(ColorHelper.getResourcesColor(this, R.color.darkGray));
        }
    }

    @Override
    public void showProgress() {
        submitDialog.show();
    }

    @Override
    public void obtainUploadAudioResult(ActionResultBean resultBean) {

    }

    @Override
    public void obtainUploadImageResult(ActionResultBean resultBean) {
//        Log.d(TAG, "obtainUploadResult: " + gson.toJson(resultBean));
        if (resultBean.isSuccess()) {
            PictureFileUtils.deleteAllCacheDirFile(this);
            /**
             * 系统路径static拼接图片返回路径
             * http://111.198.10.15:11409/static/2021-04/000bcf78345f4c1c86484efa3f9d68a2.jpeg
             */
            //2021-04\\000bcf78345f4c1c86484efa3f9d68a2.jpeg
            String url = resultBean.getData();
            int sumItemCount = imageAdapter.getItemCount() + 1;//每上传一张图片，图片总数都是在原有的基础上+1
            if (sumItemCount <= 2) {
                imageList.add(url);
                realPaths.add(StringHelper.appendCompleteURL(url));
                if (realPaths.size() == 2) {
                    addImageView.setVisibility(View.GONE);
                }
                imageAdapter.setMediaList(realPaths);
                //九宫格点击事件
                imageAdapter.setOnItemClickListener(new ImageRecycleViewAdapter.OnItemClickListener() {
                    @Override
                    public void onClick(int position) {
                        OtherUtils.showBigImage(context, position, realPaths);
                    }
                });
                //删除按钮点击事件
                imageAdapter.setOnDeleteClickListener(new ImageRecycleViewAdapter.OnDeleteItemClickListener() {
                    @Override
                    public void onClick(int position) {
                        realPaths.remove(position);
                        imageAdapter.setMediaList(realPaths);
                        if (realPaths.size() != 2) {
                            addImageView.setVisibility(View.VISIBLE);
                        }
                    }
                });
            } else {
                ToastHelper.showToast("最多只能上传2张图片", ToastHelper.WARING);
            }
        }
    }

    @Override
    public void obtainUploadVideoResult(ActionResultBean resultBean) {

    }

    /**
     * 案卷提交
     */
    private void submitCase() {
        String longitude = longitudeView.getText().toString();
        String latitude = latitudeView.getText().toString();
        if (longitude.equals("0") || latitude.equals("0") || TextUtils.isEmpty(longitude) || TextUtils.isEmpty(latitude)) {
            ToastHelper.showToast("经纬度异常，请重新选择位置", ToastHelper.WARING);
            return;
        }
        if (eorc.equals("请选择") || typeCode.equals("请选择")) {
            ToastHelper.showToast("案卷大类还未选择", ToastHelper.WARING);
            return;
        }
        if (typeDetailCode.equals("请选择")) {
            ToastHelper.showToast("案卷小类还未选择", ToastHelper.WARING);
            return;
        }
        if (TextUtils.isEmpty(gridId)) {
            ToastHelper.showToast("网格ID异常，请重新地图选点", ToastHelper.WARING);
            return;
        }
        String fieldIntro = caseLocationView.getText().toString().trim().replace(" ", "");
        if (TextUtils.isEmpty(fieldIntro)) {
            ToastHelper.showToast("案卷地点还未填写", ToastHelper.WARING);
            return;
        }
        String description = caseDetailEditView.getText().toString().trim().replace(" ", "");
        if (TextUtils.isEmpty(description)) {
            ToastHelper.showToast("案卷情况还未填写", ToastHelper.WARING);
            return;
        }
        if (imageAdapter.getItemCount() != 2) {
            ToastHelper.showToast("必须选择两张图片", ToastHelper.WARING);
            return;
        }
        caseSubmitPresenter.onReadyRetrofitRequest("0", "0", longitude, latitude,
                "1", "1", eorc, typeCode, typeDetailCode,
                gridId.substring(0, 6),
                gridId.substring(0, 9),
                gridId.substring(0, 12),
                gridId, description, fieldIntro,
                StringHelper.reformatURL(imageList), "", "", 0, 0);
    }

    @Override
    public void obtainSubmitResult(ActionResultBean resultBean) {
//        Log.d(TAG, "obtainSubmitResult: " + gson.toJson(resultBean));
        if (resultBean.isSuccess()) {
            ToastHelper.showToast("案卷提交成功", ToastHelper.SUCCESS);
            finish();
        } else {
            ToastHelper.showToast("案卷提交失败，请重试", ToastHelper.ERROR);
        }
    }

    @Override
    public void obtainDataFail() {
        ToastHelper.showToast("操作失败", ToastHelper.ERROR);
    }

    @Override
    public void hideProgress() {
        submitDialog.dismiss();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (caseLargeClassPresenter != null) {
            caseLargeClassPresenter.disposeRetrofitRequest();
        }
        if (caseSmallClassPresenter != null) {
            caseSmallClassPresenter.disposeRetrofitRequest();
        }
        if (caseSubmitPresenter != null) {
            caseSubmitPresenter.disposeRetrofitRequest();
        }
        if (uploadImagePresenter != null) {
            uploadImagePresenter.disposeRetrofitRequest();
        }
    }
}
